#include <kos.h>
#include <png/png.h>
#include "png.h"
#include "readpng.h"

/* load an n x n texture from a png */

/* not to be used outside of here */
extern void _png_copy_texture(uint8 *buffer, uint16 *temp_tex,
                      uint32 channels, uint32 stride,
                      uint32 mask, uint32 w, uint32 h);

int png_load_texture(const char * filename, uint32 *tex, uint32 mask, uint32 *w, uint32 *h)
{
    uint16 *temp_tex;

    /* More stuff */
    uint8 *buffer;            /* Output row buffer */
    uint32 row_stride;   /* physical row width in output buffer */
    uint32 channels;           /* 3 for RGB 4 for RGBA */

    FILE *infile;                /* source file */

    //    readpng_version_info();
    
    if ((infile = fopen(filename, "r")) == 0) {
      printf("png_to_texture: can't open %s\n", filename);
      return -1;
    }

    /* Step 1: Initialize loader */

    if (readpng_init(infile))
    {
      fclose(infile);
      return -1;
    }

    /* Step 2: Read file */

    buffer = readpng_get_image(&channels, &row_stride, w, h);
    temp_tex = (uint16 *)malloc(sizeof(uint16)*(*w)*(*h));

    _png_copy_texture(buffer, temp_tex,
                     channels, row_stride,
                     mask, *w, *h);

    *tex = ta_txr_allocate((*w)*(*h)*2);
    txr_twiddle_copy(temp_tex, *w, *h, *tex, *w, *h, 0);

    /* Step 3: Finish decompression */
    free(buffer);
    readpng_cleanup();

    fclose(infile);
    free(temp_tex);
    /* And we're done! */
    return 0;

}

int png_to_texture(const char * filename, uint32 tex, uint32 mask)
{
  uint16 *temp_tex;
  
  /* More stuff */
  uint8 *buffer;            /* Output row buffer */
  uint32 row_stride;   /* physical row width in output buffer */
  uint32 channels;           /* 3 for RGB 4 for RGBA */
  uint32 w,h;
  
  FILE *infile;                /* source file */

  //    readpng_version_info();
  
  if ((infile = fopen(filename, "r")) == 0) {
    printf("png_to_texture: can't open %s\n", filename);
    return -1;
  }

  /* Step 1: Initialize loader */
  
  if (readpng_init(infile))
  {
    fclose(infile);
    return -1;
  }

  /* Step 2: Read file */

  buffer = readpng_get_image(&channels, &row_stride,&w,&h);
  temp_tex = (uint16 *)malloc(sizeof(uint16)*w*h);

  _png_copy_texture(buffer, temp_tex,
                   channels, row_stride,
                   mask, w, h);

  txr_twiddle_copy(temp_tex, w, h, tex, w, h, 0);

  /* Step 3: Finish decompression */
  free(buffer);
  readpng_cleanup();

  fclose(infile);
  free(temp_tex);
  /* And we're done! */
  return 0;
}
